#!/bin/sh
# 
# Copyright (c) 2008 Motorola Inc
#
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at
# your option) any later version.  You should have
# received a copy of the GNU General Public License
# along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave,
# Cambridge, MA 02139, USA
#
# This Program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A
# PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# Date          Author          Comment
# 05/09/2008    Motorola        create
# 06/24/2008    Motorola        Add aplog core dump processing

R_DONE=0
E_MKDIR=1
E_PARSE=2
E_COPY=3
E_MEM=4
E_PS=5
E_DMESG=6

APLOG_CORE_DUMP_PHONE_DIR=/ezxlocal/app_dump
APLOG_CORE_DUMP_MMC_DIR=/mmc/mmca1/app_dump

APLOGD_CONF_FILE=/ezxlocal/logger/aplogd_config
DES_BASE_DIR=/mmc/mmca1/log_coredump
CORE_NAME=${4##*/}
DES_CORE_NAME_DIR=$DES_BASE_DIR/$CORE_NAME

SYS_MEM_INFO=$DES_CORE_NAME_DIR/$CORE_NAME.meminfo.txt
SYS_PS_INO=$DES_CORE_NAME_DIR/$CORE_NAME.ps.txt
KERNEL_MSG=$DES_CORE_NAME_DIR/$CORE_NAME.dmesg.txt

for core in `ls $APLOG_CORE_DUMP_MMC_DIR` ; do
  if [ ${core##*\.} -lt $3 ] && [ ! -e $APLOG_CORE_DUMP_PHONE_DIR/$core ] ; then
     if [ `ls -l $APLOG_CORE_DUMP_MMC_DIR/$core | awk '{print $5}'` -le $2 ] ; then
       cp -a -f $APLOG_CORE_DUMP_MMC_DIR/$core $APLOG_CORE_DUMP_PHONE_DIR || exit $E_COPY
     else
       ln -s -f $APLOG_CORE_DUMP_MMC_DIR/$core $APLOG_CORE_DUMP_PHONE_DIR/$core
     fi
   fi
done

if [ ! -e $DES_BASE_DIR ] ; then
  mkdir $DES_BASE_DIR || exit $E_MKDIR
fi

if [ ! -e $DES_CORE_NAME_DIR ] ; then
  mkdir $DES_CORE_NAME_DIR || exit $E_MKDIR
fi

SRC_FILE=`/bin/sed -n -e /logfile_path/s%logfile_path\ *=\ *%%p $APLOGD_CONF_FILE `

if [ "$SRC_FILE" = '' ] ; then
  exit $E_PARSE
fi

APLOG_BACKUP=$DES_CORE_NAME_DIR/$CORE_NAME.${SRC_FILE##*/}

if [ -f $SRC_FILE ] ; then
  sync
  cp -f $SRC_FILE  $APLOG_BACKUP || exit $E_COPY
fi

cat /proc/meminfo > $SYS_MEM_INFO || exit $E_MEM
ps > $SYS_PS_INO || exit $E_PS
busybox dmesg > $KERNEL_MSG  || exit $E_DMESG


exit $R_DONE

